Subject: Re: [PATCH net-next 14/15] net: sparx5: add compatible strings for lan969x and verify the target

From: Simon Horman <[email-masked]>
Date: Tue, 22 Oct 2024 09:50:50 +0100

On Mon, Oct 21, 2024 at 03:58:51PM +0200, Daniel Machon wrote:
> Add compatible strings for the twelve lan969x SKU's (Stock Keeping Unit)
> that we support, and verify that the devicetree target is supported by
> the chip target.
> 
> Each SKU supports different bandwidths and features (see [1] for
> details). We want to be able to run a SKU with a lower bandwidth and/or
> feature set, than what is supported by the actual chip. In order to
> accomplish this we:
> 
>     - add new field sparx5->target_dt that reflects the target from the
>       devicetree (compatible string).
> 
>     - compare the devicetree target with the actual chip target. If the
>       bandwidth and features provided by the devicetree target is
>       supported by the chip, we approve - otherwise reject.
> 
>     - set the core clock and features based on the devicetree target
> 
> [1] https://www.microchip.com/en-us/product/lan9698
> 
> Reviewed-by: Steen Hegelund <[email-masked]>
> Signed-off-by: Daniel Machon <[email-masked]>
> ---
>  drivers/net/ethernet/microchip/sparx5/Makefile     |   1 +
>  .../net/ethernet/microchip/sparx5/sparx5_main.c    | 194 ++++++++++++++++++++-
>  .../net/ethernet/microchip/sparx5/sparx5_main.h    |   1 +
>  3 files changed, 193 insertions(+), 3 deletions(-)
> 
> diff --git a/drivers/net/ethernet/microchip/sparx5/Makefile b/drivers/net/ethernet/microchip/sparx5/Makefile
> index 3435ca86dd70..8fe302415563 100644
> --- a/drivers/net/ethernet/microchip/sparx5/Makefile
> +++ b/drivers/net/ethernet/microchip/sparx5/Makefile
> @@ -19,3 +19,4 @@ sparx5-switch-$(CONFIG_DEBUG_FS) += sparx5_vcap_debugfs.o
>  # Provide include files
>  ccflags-y += -I$(srctree)/drivers/net/ethernet/microchip/vcap
>  ccflags-y += -I$(srctree)/drivers/net/ethernet/microchip/fdma
> +ccflags-y += -I$(srctree)/drivers/net/ethernet/microchip/lan969x
> diff --git a/drivers/net/ethernet/microchip/sparx5/sparx5_main.c b/drivers/net/ethernet/microchip/sparx5/sparx5_main.c
> index 5c986c373b3e..edbe639d98c5 100644
> --- a/drivers/net/ethernet/microchip/sparx5/sparx5_main.c
> +++ b/drivers/net/ethernet/microchip/sparx5/sparx5_main.c
> @@ -24,6 +24,8 @@
>  #include <linux/types.h>
>  #include <linux/reset.h>
>  
> +#include "lan969x.h" /* lan969x_desc */
> +

Hi Daniel,

Perhaps this will change when Krzysztof's comment elsewhere in this thread
is addressed. But as it stands the construction in the above two hunks
appears to cause a build failure.

  CC      drivers/net/ethernet/microchip/sparx5/sparx5_main.o
In file included from drivers/net/ethernet/microchip/sparx5/sparx5_main.c:27:
./drivers/net/ethernet/microchip/lan969x/lan969x.h:10:10: fatal error: sparx5_main.h: No such file or directory
   10 | #include "sparx5_main.h"
      |          ^~~~~~~~~~~~~~~

My preference would be to move away from adding -I directives and, rather,
use relative includes as is common practice in Networking drivers (at least).

...

-- 
pw-bot: changes-requested